unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, vector, universe, prefs, StdCtrls, Buttons, ExtCtrls, ActnMan,
  ActnColorMaps;

type
  TForm1 = class(TForm)
    PlanetInfo: TGroupBox;
    PlanetList: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    X: TEdit;
    Y: TEdit;
    Z: TEdit;
    Label3: TLabel;
    Mass: TEdit;
    Delete: TButton;
    Save: TButton;
    Polomer: TEdit;
    Label4: TLabel;
    SitOn: TButton;
    Simulation: TGroupBox;
    Start: TButton;
    Preferences: TButton;
    Exit: TButton;
    Timer1: TTimer;
    LookAt: TButton;
    VX: TEdit;
    Label5: TLabel;
    VY: TEdit;
    VZ: TEdit;
    Popis: TStaticText;
    Label6: TLabel;
    Track: TEdit;
    Label7: TLabel;
    Collour: TButton;
    ColorDiag: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure PlanetListChange(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure aktualize(Sender: TObject); overload;
    procedure DeleteClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure StartClick(Sender: TObject);
    procedure SetActivePlanet(Sender: TObject);
    procedure SitOnClick(Sender: TObject);
    procedure LookAtClick(Sender: TObject);
    procedure PreferencesClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure TrackChange(Sender: TObject);
    procedure CollourClick(Sender: TObject);
  private
    lastcolor: TColor;
    { Private declarations }
  public
    { Public declarations }
    procedure Aktualize; overload;
  end;

var
  Form1: TForm1;
  TargetPlanet: PPlanet;
  Universe: TUniverse;
  Preferencs: TPreferences;

implementation

{$R *.dfm}

{neco pro aktualizaci stavu}
procedure TForm1.aktualize(Sender: TObject);
begin
  self.aktualize;
end;

procedure TForm1.SetActivePlanet(Sender: Tobject);
begin
  PlanetList.Text:=(Sender as TPlanet).name;
  self.PlanetListChange(Sender);
end;

procedure TForm1.aktualize;
begin
  PlanetInfo.Left:=self.ClientWidth-(10+PlanetInfo.Width);
  PlanetInfo.Top:= 10;
  Simulation.Left:=PlanetInfo.Left;
  Simulation.Top:=PlanetInfo.Top+PlanetInfo.Height+10;
  Universe.Top:=10;
  Universe.Left:=10;
  Universe.Width:=PlanetInfo.Left-20;
  Universe.Height:=self.ClientHeight-20;
  Universe.obraz.Width:=Universe.Width-2;
  Universe.obraz.Height:=Universe.Height-2;
  self.PlanetListChange(self);
  self.TrackChange(self);
  universe.Refresh;
end;

{inicializace}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Universe:=TUniverse.Create(Form1);
  Form1.InsertControl(Universe);
  Form1.Lastcolor:=clWhite;
  Form1.aktualize;
  Popis.BringToFront;
  TargetPlanet:=NIL;
  Universe.Refresh;
end;

{ zmenil se vyber planety }
procedure TForm1.PlanetListChange(Sender: TObject);
var num: array [1..3] of variant;
begin
  TargetPlanet:=Universe.GetPlanet(PlanetList.Text); {existuje takova planeta?}
  if TargetPlanet<>NIL then
  begin {pokud ano, tak by to chtelo nacist jeji data...}
    PlanetList.Text:=TargetPlanet^.Name;
    num[1]:=TargetPlanet^.getmass;
    mass.Text:=num[1];
    num[1]:=TargetPlanet^.getradius;
    Polomer.Text:=num[1];
    TargetPlanet^.getposition(num[1],num[2],num[3]);
    X.text:=num[1];
    Y.text:=num[2];
    z.text:=num[3];
    Colordiag.Color:=TargetPlanet^.Brush.Color;
    Form1.lastcolor:=Colordiag.Color;
    TargetPlanet^.GetVelocity(num[1],num[2],num[3]);
    VX.text:=num[1];
    VY.text:=num[2];
    VZ.text:=num[3];
  end;   {osetreni par tlacitek}
  if TargetPlanet=NIL then
    begin
      Save.Caption:='&Add';
      Delete.Enabled:=False;
      SitOn.Enabled:=False;
      SitOn.Caption:='Sit &on';
      LookAt.Enabled:=False;
      LookAt.Caption:='Loo&k at';
    end else begin
      Save.Caption:='&Save';
      Delete.Enabled:=True;
      SitOn.Enabled:=True;
      if TargetPlanet=Universe.Sit then
        begin
          SitOn.Caption:='Get &off';
        end else begin
          SitOn.Caption:='Sit &on';
        end;
      LookAt.Enabled:=True;
      if TargetPlanet=Universe.Look then
        begin
          LookAt.Caption:='Fixed loo&k';
        end else begin
          LookAt.Caption:='Loo&k at';
        end;
    end;
end;

{ ukladani udaju o planete}
procedure TForm1.SaveClick(Sender: TObject);
var tmp: vektor;
    num: variant;
    a: PPlanet;
    err:boolean;
begin
  a:=NIL;
  err:=false;
try  { kdyby nevysla konverze datovych typu ;-) }
  num:=X.Text;
  tmp.x:=num;
  num:=Y.Text;
  tmp.y:=num;
  num:=Z.Text;
  tmp.z:=num;
  if TargetPlanet=NIL then     {pokud planeta pozadovaneho jmena neexistuje,}
    begin                      {tak ji vytvorime}
      new(a);
      a^:=(Tplanet.Create(@Universe,PlanetList.Text));
      if length(PlanetList.Text)=0 then
        err:=true;
    end else
      a:=TargetPlanet;
  a^.setposition(tmp);
  num:=VX.Text;
  tmp.x:=num;
  num:=VY.Text;
  tmp.y:=num;
  num:=VZ.Text;
  tmp.z:=num;
  a^.SetVelocity(tmp);
  a^.Brush.Color:=colordiag.Color;
  num:=Mass.Text;
  a^.setmass(num);
  num:=Polomer.Text;
  a^.setradius(num);
except            {pokud nevysla konverze, zaznamena se to,}
  on EVariantTypeCastError do
  begin
    err:=true;
  end
  else err:=true
end;
  if err=false then
    begin
      if TargetPlanet=NIL then
      begin
        Universe.AddPlanet(a);
        PlanetList.Items.Add(Planetlist.Text);
      end;
    end else begin         {, vypise se chyba a smaze se vytvorena planeta}
      showmessage('Invalid value(s) in input field(s)!!');
      if (TargetPlanet=NIL) and (a<>NIL) then
      begin
        a^.Destroy;
        dispose(a);
      end;
    end;
  if (TargetPlanet<>NIL) and ((TargetPlanet=Universe.Sit) or (TargetPlanet=Universe.Look)) then
    Universe.AddTime(0);
  TargetPlanet:=a;
  PlanetList.Update;
  Form1.aktualize;
end;

procedure TForm1.DeleteClick(Sender: TObject);
begin
  Universe.DestroyPlanet(PlanetList.Text);
  Form1.PlanetList.Items.Clear;
  Universe.GetPlanets(@Form1.PlanetList.Items);
  Form1.Aktualize;
  Universe.Refresh;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i: integer;
begin
for i:=1 to 10000 do
begin
  Universe.AddTime(universe.constants.t/10000);
end;
Form1.aktualize;
end;


procedure TForm1.StartClick(Sender: TObject);
begin
if Form1.Start.Caption='S&tart' then
  begin
    Form1.Start.Caption:='S&top';
    Timer1.Interval:=100;
    Timer1.Enabled:=True;
  end
else
  begin
    Form1.Start.Caption:='S&tart';
    Timer1.Enabled:=False;
  end;
end;


procedure TForm1.SitOnClick(Sender: TObject);
begin
  if SitOn.Caption='Sit &on' then
    begin
      Universe.Sit:=TargetPlanet;
    end else
      Universe.Sit:=NIL;
  Universe.Refresh;
  PlanetListChange(self);
end;

procedure TForm1.LookAtClick(Sender: TObject);
begin
  if LookAt.Caption='Loo&k at' then
  begin
    Universe.Look:=TargetPlanet;
  end else
    Universe.Look:=NIL;
  Universe.Refresh;
  PlanetListChange(self);
end;


procedure TForm1.PreferencesClick(Sender: TObject);
var tmp1, tmp2: variant;
begin
  if Start.Caption<>'S&tart' then
    StartClick(self);
  tmp1:=Universe.constants.v;
  Preferencs.VelocityVal.Text:=tmp1;
  getpow(universe.constants.l,tmp1,tmp2);
  Preferencs.DistUni.Text:=tmp2;
  Preferencs.DistPow.Text:=tmp1;
  getpow(universe.constants.f,tmp1,tmp2);
  Preferencs.FrUni.Text:=tmp2;
  Preferencs.FrPow.Text:=(-tmp1);
  getpow(universe.constants.m,tmp1,tmp2);
  Preferencs.MassUni.Text:=tmp2;
  Preferencs.MassPow.Text:=tmp1;
  tmp1:=trunc(universe.constants.t/600);
  Preferencs.Seconds.Text:=(universe.constants.t-tmp1*600)/10;
  tmp2:=trunc(tmp1/60);
  Preferencs.Minutes.Text:=tmp1-tmp2*60;
  tmp1:=trunc(tmp2/24);
  Preferencs.Hours.Text:=tmp2-tmp1*24;
  Preferencs.Day.Text:=tmp1;
  Preferencs.Left:=Round(Form1.Left+Form1.Width/2-Preferencs.Width/2);
  Preferencs.Top:=Round(Form1.Top+Form1.Height/2-Preferencs.Height/2);
  Preferencs.Visible:=true;
  Form1.Enabled:=False;
end;

procedure TForm1.ExitClick(Sender: TObject);
begin
self.Close;
end;

procedure TForm1.TrackChange(Sender: TObject);
var num: variant;
begin
  try
    num:=Track.Text;
    if length(num)>0 then
      Universe.constants.TrackLenght:=num*10;
  except
    showmessage('Invalid value in input field!!');
  end;
end;


procedure TForm1.CollourClick(Sender: TObject);
begin
if not ColorDiag.Execute then
  colorDiag.Color:=Form1.lastcolor;
end;

end.
