unit vector;

interface

type vektor=object
  public
    x:double;
    y:double;
    z:double;
    procedure multiplyby(a: vektor); overload;
    procedure multiplyby(a: double); overload;
    function multipliedby(a: vektor): vektor; overload;
    function multipliedby(a: double): vektor; overload;
    function GetZXAngle: double;
    function GetZYAngle: double;
    procedure null;
    function negative: vektor;
    function add(a: vektor): vektor;
    function getnorm: double;
    function setnorm(kolik: double): vektor;
end;

function Power(X: double; Y: Integer): double;
procedure getpow(x: double; var pow: variant; var els: variant);
function Max(X: double; Y:double): double;
implementation

{vrati maximum}
function Max(X: double; Y:double): double;
begin
if x>y then
  begin
    result:=x;
  end else begin
    result:=y;
  end;
end;

{vrati mocninu cisla}
function Power(X: double; Y: Integer): double;
var
  I: Integer;
begin
  Result := 1;
  if Y>=0 then
  begin
  I := Y;
  while I > 0 do
  begin
    if Odd(I) then Result := Result * X;
    I := I div 2;
    X := Sqr(X);
  end;
  end else
    Result:=1/power(X,-Y);
end;

{ vrati pocet nul a to pred nimi}
procedure getpow(x: double; var pow: variant; var els: variant);
var count: integer;
begin
  count:=0;
  If (x>=1) or (x=0) then
  begin
  while x>power(10,10) do
  begin
    inc(count);
    x:=x/10;
  end;
  while (x/10=trunc(x/10)) and (x<>0) do
    begin
      inc(count);
      x:=x/10;
    end;
  pow:=count;
  els:=x;
  end else begin
  while x<power(10,-10) do
  begin
    inc(count);
    x:=x*10;
  end;
  while (trunc(x)=0) do
    begin
      inc(count);
      x:=x*10;
    end;
  pow:=-count;
  els:=x;
  end;
end;

{vynasobi vektor vektorem}
procedure vektor.multiplyby(a: vektor);
begin
  self.x:=self.x*a.x;
  self.y:=self.y*a.y;
  self.z:=self.z*a.z;
end;

{vynasobi vektor skalarem}
procedure vektor.multiplyby(a: double);
begin
  self.x:=self.x*a;
  self.y:=self.y*a;
  self.z:=self.z*a;
end;

{vrati vektor vynasobeny vektorem}
function vektor.multipliedby(a: vektor): vektor;
var tmp: vektor;
begin
  tmp:=self;
  tmp.multiplyby(a);
  multipliedby:=tmp;
end;

{vrati vektor vynasobeny skalarem}
function vektor.multipliedby(a: double): vektor;
var tmp: vektor;
begin
  tmp:=self;
  tmp.multiplyby(a);
  multipliedby:=tmp;
end;

{vynuluje vektor}
procedure vektor.null;
begin
  self.x:=0;
  self.y:=0;
  self.z:=0;
end;

{vrati -vektor}
function vektor.negative: vektor;
var tmp: vektor;
begin
  tmp.x:=-self.x;
  tmp.y:=-self.y;
  tmp.z:=-self.z;
  negative:=tmp;
end;

{vrati soucet vektoru}
function vektor.add(a: vektor):vektor;
var tmp: vektor;
begin
  tmp.x:=self.x+a.x;
  tmp.y:=self.y+a.y;
  tmp.z:=self.z+a.z;
  add:=tmp;
end;

{vrati velikost vektoru}
function vektor.getnorm: double;
begin
  getnorm:=sqrt(self.x*self.x+self.y*self.y+self.z*self.z);
end;

{nastavi velikost vektoru}
function vektor.setnorm(kolik: double): vektor;
begin
  if self.getnorm=0 then
  begin
    result.x:=1;
    result.y:=1;
    result.z:=1;
    result.multiplyby(kolik);
  end else
  setnorm:=self.multipliedby(kolik/self.getnorm);
end;


function vektor.GetZXAngle: double;
begin
  result:=0;
  if self.z=0 then
    begin
      if x>0 then
        result:=ArcTan(1)*2;
      if x<0 then
        result:=ArcTan(1)*6;
    end;
  if (self.z>0) then
  begin
    result:=ArcTan(self.x/self.z);
  end else begin
    if self.z<0 then
      result:=ArcTan(self.x/self.z)-ArcTan(1)*4;
  end;
  if result<0 then
    result:=result+ArcTan(1)*8;
end;

function vektor.GetZYAngle: double;
begin
  result:=0;
  if self.z=0 then
    begin
      if y>0 then
        result:=ArcTan(1)*2;
      if y<0 then
        result:=ArcTan(1)*6;
    end;
  if (self.z>0) then
  begin
    result:=ArcTan(self.y/self.z);
  end else begin
    if self.z<0 then
      result:=ArcTan(self.y/self.z)-ArcTan(1)*4;
  end;
  if result<0 then
    result:=result+ArcTan(1)*8;
end;


end.
